﻿using UnityEngine;
using System.Collections;

public class playerController : MonoBehaviour {
	//Creamos las variables publicas para controlar el salto y velocidad
	public float fuerzaSalto;
	public float velocidadMovimiento;
	
	// Variables para controlar el doble salto, este solo en el suelo
	public Transform sueloCheck;
	public float sueloCheckRadio = 0.1f;
	public LayerMask sueloLayer;
	private bool enSuelo;
	private bool dobleSalto;

	//Variables para controlar la animación del player
	private Animator animacion;

	//Variable para quitar la sensación de patinar el Player
	private float moveVelocity;

	//Variable para controlar el disparo
	public Transform focoDisparo;
	//Variable para controlar la bala
	public GameObject bala;

	//Variable para controlar el sonido del salto
	public AudioSource sonidoSalto;


	
	// Use this for initialization
	void Start () {

		//Iniciamos la animación del player
		animacion = GetComponent<Animator>();
	}
	
	//Añadimos una nueva funcion para controlar la física
	void FixedUpdate() {
		
		enSuelo = Physics2D.OverlapCircle(sueloCheck.position,sueloCheckRadio,sueloLayer);
		
	}
	
	// Update is called once per frame
	void Update () {
		//Verificamos si está el personaje en el suelo
		if (enSuelo) {
			dobleSalto=false;
		}
		animacion.SetBool("grounded",enSuelo);
		
		
		//Si pulsamos tecla espaciadora, el personaje saltará se controla tambien si está en el suelo
		if(Input.GetKeyDown(KeyCode.Space) && enSuelo){
			GetComponent<Rigidbody2D>().velocity = new Vector2(GetComponent<Rigidbody2D>().velocity.x,fuerzaSalto);
			//Reproducimos el sonido del salto
			sonidoSalto.Play();
		}

		if(Input.GetKeyDown(KeyCode.Space) && !dobleSalto && !enSuelo){
			GetComponent<Rigidbody2D>().velocity = new Vector2(GetComponent<Rigidbody2D>().velocity.x,fuerzaSalto);
			dobleSalto=true;
		}

		//Iniciamos la variable a 0
		moveVelocity = 0f;

		//Si pulsamos la D, desplazamos el personaje a la derecha
		if(Input.GetKey(KeyCode.D)){
			//GetComponent<Rigidbody2D>().velocity = new Vector2(velocidadMovimiento,GetComponent<Rigidbody2D>().velocity.y);
			//Con este metodo conseguimos que no patine el player
			moveVelocity=velocidadMovimiento;
		}
		//Si pulsamos la A, desplazamos el personaje a la Izquierda
		if(Input.GetKey(KeyCode.A)){
			//GetComponent<Rigidbody2D>().velocity = new Vector2(-velocidadMovimiento,GetComponent<Rigidbody2D>().velocity.y);
			//Con este metodo conseguimos que no patine el player
			moveVelocity=-velocidadMovimiento;
		}

		//Creamos balas cuando pulsamos la letra M
		if (Input.GetKeyDown(KeyCode.M)) {
			Instantiate(bala,focoDisparo.position,focoDisparo.rotation);

		}

		GetComponent<Rigidbody2D>().velocity = new Vector2 (moveVelocity, GetComponent<Rigidbody2D> ().velocity.y);

		//Controlamos el parametro speed, de atributo de la animación para que detectemos si camina o no mediante la posicion X
		animacion.SetFloat("speed",Mathf.Abs(GetComponent<Rigidbody2D>().velocity.x));
		// Controlamos que la imagen se gire cuando nos desplacemos a la izquierda
		if (GetComponent<Rigidbody2D>().velocity.x>0)
			transform.localScale = new Vector3(1f,1f,1f);
		else if (GetComponent<Rigidbody2D>().velocity.x <0)
			transform.localScale = new Vector3(-1f,1f,1f);
	}
}
